﻿--DROP PROCEDURE insert_resource_code;
CREATE PROCEDURE insert_resource_code(@p_parentResourceCode text, @p_resourceCode text, @p_resourceName text, @p_tableName text, @p_userId bigint) 
AS 
  BEGIN 
    declare @_resourceId bigint
    declare @_actionId bigint
    DECLARE @tempTable TABLE ("actionId" bigint)

    INSERT INTO "authResources" ("parentResourceCode", "resourceCode", "resourceName", "tableName", "resourceType", "orderIndex", "status", "createdUserId") 
        VALUES (@p_parentResourceCode, @p_resourceCode, @p_resourceName, @p_tableName, 0, 0, 1, @p_userId)
    
    SELECT @_resourceId = SCOPE_IDENTITY()
    
    INSERT INTO "authActions" ("resourceId", "actionType", "orderIndex", status, "createdUserId", "createdDate")
        OUTPUT inserted."actionId" INTO @tempTable
        SELECT @_resourceId,"par"."value", 0,1, @p_userId, getdate() FROM  "coreParameters" par
           WHERE par."keyCode"='AUTH_ACTION_TYPE'
           ORDER BY par."orderIndex"
                 
    INSERT INTO "authUserRights" ("actionId", "userId","recordType","groupActionId","status","createdUserId","createdDate")
        SELECT "actionId", @p_userId,0,0,1,@p_userId,getdate() FROM @tempTable
   
  END;