﻿CREATE OR REPLACE PROCEDURE insert_resource_code(p_parentResourceCode varchar2, p_resourceCode varchar2, p_resourceName varchar2, p_tableName varchar2, p_userId NUMBER) 
IS 
    v_resourceId NUMBER := 0;
    v_actionId number := 0;
    v_actionValue number := 0;
    CURSOR cursor_actions IS
      		SELECT par."value"
           	FROM  "coreParameters" par
           	WHERE par."keyCode"='AUTH_ACTION_TYPE'
           	ORDER BY par."orderIndex";
BEGIN
	IF NVL(v_resourceId,0)=0 THEN	
    	INSERT INTO "authResources" ("parentResourceCode", "resourceCode", "resourceName", "tableName", "resourceType", "orderIndex", "status", "createdUserId", "createdDate") 
        VALUES (p_parentResourceCode, p_resourceCode, p_resourceName, p_tableName, 0, 0, 1, p_userId, CURRENT_DATE)
        RETURNING "resourceId" INTO v_resourceId ;
       
    	--SELECT "authResources_SEQ".CURRVAL INTO v_resourceId FROM dual;
    END IF;
    
    FOR v_cursor IN cursor_actions
    LOOP
    	INSERT INTO "authActions" ("resourceId", "actionType", "orderIndex", "status", "createdUserId", "createdDate")
        	VALUES (v_resourceId, v_cursor."value", 0, 1, p_userId, CURRENT_DATE)
        	RETURNING "actionId" INTO v_actionId ;
      
    	--SELECT "authActions_SEQ".CURRVAL INTO v_actionId FROM dual;
        
        INSERT INTO "authUserRights" ("actionId", "userId","recordType","groupActionId","status","createdUserId","createdDate")
            VALUES (v_actionId, p_userId, 0, 0, 1, p_userId, CURRENT_DATE);
    END LOOP;
END;
