﻿using System.Threading.Tasks;
using CoreSvc.Filters;
using CoreType.Types;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using __svcProjectName.Services;
using __typeProjectName.DBModels;

namespace __svcProjectName.Controllers
{
    [Authorize]
    [DefaultRoute]
    [Resources("__resourceCode")]
    public class __nameController : BaseController
    {
        private readonly __nameService _mainService = new __nameService();

        [HttpPost]
        [ClaimRequirement(ActionType.List)]
        public async Task<ResponseWrapper<PaginationWrapper<__modelName>>> List([FromBody] RequestWithPagination<__modelName> request)
        {
            return await _mainService.ListAsync(request);
        }

        [HttpPost]
        [ClaimRequirement(ActionType.GetRecord)]
        public async Task<ResponseWrapper<__modelName>> Get([FromBody] __modelName request)
        {
            return await _mainService.GetAsync(request);
        }

        [HttpPost]
        [ClaimRequirement(ActionType.Insert)]
        public async Task<ResponseWrapper<__modelName>> Insert([FromBody] __modelName request)
        {
            return await _mainService.SaveAsync(request);
        }

        [HttpPost]
        [ClaimRequirement(ActionType.Update)]
        public async Task<ResponseWrapper<__modelName>> Update([FromBody] __modelName request)
        {
            return await _mainService.SaveAsync(request);
        }

        [HttpPost]
        [ClaimRequirement(ActionType.Import)]
        public Task<ResponseWrapper> BulkSave([FromBody] RequestWithExcelData<__modelName> request)
        {
            return _mainService.BulkSaveAsync(request);
        }

        [HttpPost]
        [ClaimRequirement(ActionType.Delete)]
        public async Task<ResponseWrapper<bool>> Delete([FromBody] __modelName request)
        {
            return await _mainService.DeleteAsync(request);
        }
    }
}