﻿using CoreData.Infrastructure;
using CoreType.Types;
using FluentValidation;
using __dataProjectName.DBContexts;

namespace __dataProjectName.Common
{
    public class GenericRepository : GenericRepositoryContext<__contextName>
    {
        protected GenericRepository()
        {
        }

        protected GenericRepository(SessionContext session) : base(session)
        {
        }

        protected GenericRepository(__contextName context, SessionContext session = null) : base(context, session)
        {
        }
    }

    public class GenericRepository<TEntity> : GenericRepositoryContext<TEntity, __contextName>
        where TEntity : class, new()
    {
        protected GenericRepository()
        {
        }

        protected GenericRepository(SessionContext session) : base(session)
        {
        }

        protected GenericRepository(__contextName context, SessionContext session = null) : base(context, session)
        {
        }
    }

    public class GenericRepository<TEntity, TKey> : GenericRepositoryContext<TEntity, TKey, __contextName>
        where TEntity : class, new()
    {
        protected GenericRepository()
        {
        }

        protected GenericRepository(SessionContext session) : base(session)
        {
        }

        protected GenericRepository(__contextName context, SessionContext session = null) : base(context, session)
        {
        }
    }

    public class GenericRepository<TEntity, TKey, TValidator> : GenericRepository<TEntity, TKey, TValidator, __contextName>
        where TEntity : class, new()
        where TValidator : IValidator<TEntity>, new()
    {
        protected GenericRepository()
        {
        }

        protected GenericRepository(SessionContext session) : base(session)
        {
        }

        protected GenericRepository(__contextName context, SessionContext session = null) : base(context, session)
        {
        }
    }
}