﻿import { IPageConfig, Methods, pageConfigWrapper, Tables } from '../../../common/typeConfig';
import { getLocalizedText } from '../../../common/localizationManager';
import __entityName from '../../../entities/__entityName';
import Constants from '../../../common/constants';

const { LIST, GET, INSERT, UPDATE, DELETE, EXPORT, IMPORT } = Methods;

let pageConfig: IPageConfig = {
  headerTitle: getLocalizedText('SEARCH_LIST_TITLE'),
  tabs: [
    {
      title: '__entityTitleName Title',
      type: __entityName,
      resourceCode: '__resourceCode',
      editOnModal: false,
      list: {
        url: `__serviceUrl/list`
      },
      get: {
        url: `__serviceUrl/get`
      },
      insert: {
        url: `__serviceUrl/insert`
      },
      update: {
        url: `__serviceUrl/update`
      },
      delete: {
        url: `__serviceUrl/delete`
      },
      import: {
        url: `__serviceUrl/bulkSaveAsync`
      },
      allowedMethods: [
        LIST,
        GET,
        INSERT,
        UPDATE,
        DELETE,
        IMPORT,
        EXPORT
      ],
    },
  ],
};

export default pageConfigWrapper(pageConfig);